package;

import flixel.FlxSprite;
import flixel.effects.particles.FlxParticle;
import flixel.math.FlxPoint;
import flixel.math.FlxVelocity;
import flixel.text.FlxText;
import flixel.FlxG;
import flixel.util.FlxColor;
import flixel.effects.particles.FlxEmitter;

class Enemy extends FlxSprite
{
	public var message:String;
	
	private var __goal:FlxPoint = new FlxPoint(960, 1080);
	
	private var __text:FlxText;
	
	private var __parent:PlayState;
	
	private var __emitter:FlxEmitter;
	
	public function new(x:Float, y:Float, parent:PlayState, word:String) 
	{
		super(x, y);
		
		loadGraphic(AssetPaths.enemy2__png, true, 78, 41);
		
		animation.add("idle", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 28, false);
		
		__parent = parent;
		
		//this.x = x;
		
		//this.y = y;
		
		offset.set(39, 20);
		
		message = word;
		
		__text = new FlxText(x, y - 46, 0, message, 8);
		
		__text.setFormat(AssetPaths.nokiafc22__ttf, 20, FlxColor.WHITE);
		
		__text.setBorderStyle(OUTLINE, FlxColor.BLACK, 0.5);
		
		__text.alignment = "center";
		
		__text.alpha = 0.7;
		
		FlxG.state.add(__text);
		
		__emitter = new FlxEmitter(64, 64);
		
		//__emitter.makeParticles();
		
		FlxG.state.add(__emitter);
		
		for (i in 0...20) 
		{
			var particle:FlxParticle = new FlxParticle();
			
			particle.loadGraphic(AssetPaths.smoke__png, false);
			
			particle.exists = false;
			
			__emitter.add(particle);
		}
		
		//__emitter.start(false, 1, 20);
	}
	
	override public function update(elapsed:Float):Void 
	{
		super.update(elapsed);
		
		animation.play("idle");
		
		FlxVelocity.moveTowardsPoint(this, __goal, __parent.__speed);
		
		__text.x = x - __text.width / 2;
		
		__text.y = y - 60;
		
		if (y > 932)
		{
			//__text.kill();
			
			//kill();
			
			__parent.reduce();
			
			FlxG.sound.play(AssetPaths.explosion__ogg);
		
			__parent.__group_enemies.remove(this, true);
			
			__parent.emitSmoke(x, y);
			
			__parent.add(new Explosion(x, y));
			
			__text.kill();
			
			kill();
			
			FlxG.camera.shake(0.01, 0.1);
		}
	}
	
	public function remove():Void
	{
		var sc:Int = message.length * 10;
		
		__parent.__num += sc;
		
		FlxG.sound.play(AssetPaths.explosion__ogg);
		
		__parent.__group_enemies.remove(this, true);
		
		__parent.emitSmoke(x, y);
		
		__parent.add(new Explosion(x, y));
		
		__text.kill();
		
		kill();
		
		FlxG.camera.shake(0.01, 0.1);
	}
}