package;

import flixel.FlxSprite;
import flixel.math.FlxPoint;
import flixel.math.FlxVelocity;
import flixel.FlxG;
import flixel.FlxObject;
import openfl.geom.Point;
import flixel.math.FlxMath;
import flixel.math.FlxAngle;
import flixel.effects.particles.FlxEmitter;
import flixel.effects.particles.FlxParticle;

class Missle extends FlxSprite
{
	private var __target:Enemy;
	
	private var __emitter:FlxEmitter;
	
	public function new(target:Enemy) 
	{
		super(960, 1120);
		//super(960, 500);
		
		__target = target;
		
		loadGraphic(AssetPaths.missile__png, false, 72, 72);
		
		offset.set(36, 36);
		
		var point:FlxPoint = __target.getPosition();
		
		angle = Math.atan2(point.x, point.y) * 180 / Math.PI;
		
		angle -= 90;
		
		__emitter = new FlxEmitter(64, 64);
		
		//__emitter.makeParticles();
		
		FlxG.state.add(__emitter);
		
		for (i in 0...40) 
		{
			var particle:FlxParticle = new FlxParticle();
			
			particle.loadGraphic(AssetPaths.smoke__png, false);
			
			particle.exists = false;
			
			particle.offset.set(5, 0);
			
			__emitter.add(particle);
		}
		
		//__emitter.start(false, 0.05, 20);
		//
		////__emitter.color.set(0xFFFFFFFF, null, 0xFF000000, null);
		//
		//__emitter.alpha.set(1, null, 0, null);
		//
		//__emitter.setSize(8, 8);
		
		//__emitter.scale.set(0.5, 1, 2, 2.5);
		
		__emitter.alpha.set(1, null, 0, null);
		
		__emitter.lifespan.set(1.4, 1.6);
		
		__emitter.speed.set(8, 16, 32, 64);
		
		__emitter.angularVelocity.set(8, 16, 32, 64);
		
		//__emitter.angle.set(0, null, 360, null);
		
		__emitter.setSize(8, 8);
		
		__emitter.start(false, 0.02, 40);
	}
	
	override public function update(elapsed:Float):Void 
	{
		super.update(elapsed);
		
		__emitter.x = x;
		
		__emitter.y = y;
		
		var point:FlxPoint = __target.getPosition();
		
		//var rotation:Float = Math.atan2(point.x, point.y) * 180 / Math.PI;
		
		//FlxVelocity.accelerateTowardsObject(this, __target, 20000, 80000);
		FlxVelocity.moveTowardsObject(this, __target, 1200);
		
		var rotation = FlxAngle.angleBetween(this, __target, true);
		
		//__emitter.angle.set(rotation, null, rotation, null);
		
		angle = rotation + 90;
		
		FlxG.overlap(this, __target, collisionCheck);
	}
	
	private function collisionCheck(Object1:FlxObject, Object2:FlxObject):Void
	{
		this.__emitter.emitting = false;
		
		__target.remove();
		
		this.kill();
	}
}