package;

import flixel.FlxState;
import flixel.addons.display.FlxBackdrop;
import flixel.group.FlxSpriteGroup.FlxTypedSpriteGroup;
import flixel.system.FlxSound;
import flixel.text.FlxText;
import flixel.util.FlxTimer;
import flixel.FlxG;
import flixel.input.keyboard.FlxKey;
import flixel.util.FlxColor;
import openfl.filters.ShaderFilter;
import flixel.system.FlxAssets.FlxShader;
import flixel.effects.particles.FlxEmitter;
import flixel.effects.particles.FlxParticle;
import flixel.math.FlxRandom;
import Global;

class PlayState extends FlxState
{
	private var __backdrop:FlxBackdrop;
	
	private var __earth:Earth;
	
	private var __clouds:Clouds;
	
	private var __timer_enemySpawn:FlxTimer;
	
	private var __timer_newWave:FlxTimer;
	
	private var __preMessage:FlxText;
	
	private var __message:FlxText;
	
	private var __score:FlxText;
	
	public var __num:Int = 0;
	
	public var __group_enemies:FlxTypedSpriteGroup<Enemy>;
	
	public var __group_hearts:FlxTypedSpriteGroup<Heart>;
	
	private var __filter_scanline:ShaderFilter;
	
	private var __emitter:FlxEmitter;
	
	private var __sfx_music:FlxSound;
	
	private var __sfx_ambient:FlxSound;
	
	private var __words:Array<String> = [];
	
	private var __level:Int = 1;
	
	private var __goal:Int = 10;
	
	private var __finished:Bool = false;
	
	public var __speed:Int = 80;
	
	private var __logo:Logo;
	
	private var __gameOver:Gameover;
	
	private var __menu:Bool = true;
	
	override public function create():Void
	{
		super.create();
		
		__backdrop = new FlxBackdrop(AssetPaths.backdrop__png);
		
		__earth = new Earth();
		
		__clouds = new Clouds();
		
		__preMessage = new FlxText(24, 1000);
		
		__message = new FlxText(144, 1025);
		
		__score = new FlxText(1446, 1013);
		
		__emitter = new FlxEmitter(64, 64);
		
		__logo = new Logo(940, 380);
		
		__gameOver = new Gameover(940, 380);
		
		__sfx_music = FlxG.sound.load(AssetPaths.ggj19__ogg, 1.5, true);
		
		__sfx_ambient = FlxG.sound.load(AssetPaths.ambient_space__ogg, 1, true);
		
		//__emitter.makeParticles();
		
		__preMessage.setFormat(AssetPaths.nokiafc22__ttf, 20, FlxColor.WHITE, LEFT);
		__preMessage.setBorderStyle(OUTLINE, FlxColor.BLACK, 0.5);
		__preMessage.text = "C:/User/Teacup/MissileLaunch.exe\nTarget:";
		__preMessage.alpha = 0.4;
		
		__score.setFormat(AssetPaths.nokiafc22__ttf, 20, FlxColor.WHITE, LEFT);
		__score.setBorderStyle(OUTLINE, FlxColor.BLACK, 0.5);
		__score.text = "Score: ";
		__score.alpha = 0.4;
		
		__message.setFormat(AssetPaths.nokiafc22__ttf, 20, FlxColor.WHITE, CENTER);
		
		__message.setBorderStyle(OUTLINE, FlxColor.BLACK, 0.5);
		
		add(__backdrop);
		
		add(__earth);
		
		add(__clouds);
		
		add(__preMessage);
		
		add(__message);
		
		add(__score);
		
		add(__emitter);
		
		add(__logo);
		//add(__gameOver);
		
		__group_enemies = new FlxTypedSpriteGroup<Enemy>();
		
		__group_hearts = new FlxTypedSpriteGroup<Heart>();
		
		var xh = 1700;
		
		for (i in 0...4) 
		{
			var heart:Heart = new Heart(xh, 1024);
			
			xh += 32;
			
			__group_hearts.add(heart);
			
			add(heart);
		}
		
		__timer_enemySpawn = new FlxTimer();
		
		__timer_newWave = new FlxTimer();
		
		__filter_scanline = new ShaderFilter(new Scanline());
		
		FlxG.game.setFilters([__filter_scanline]);
		
		//__sfx_music = new FlxSound();
		
		__words = Global.level_2;
		
		FlxG.random.shuffle(__words);
		
		__sfx_ambient.play();
		
		//__preMessage.setPosition(860, 660);
		
		//__preMessage.text = "PRESS ENTER!";
		
		//setLevel();
		
		FlxG.camera.shake(0.01, 0.3);
		
		FlxG.sound.play(AssetPaths.braaam__ogg);
		
		__emitter.alpha.set(1, null, 0, null);
		
		__emitter.lifespan.set(0.4, 0.8);
		
		__emitter.speed.set(32, 64, 128, 150); 
		
		__emitter.angularVelocity.set(32, 64, 128, 150);
		
		//__emitter.angle.set(0, null, 360, null);
		
		__emitter.setSize(64, 64);
	}

	override public function update(elapsed:Float):Void
	{
		super.update(elapsed);
		
		//** Update backdrop.
		
		__backdrop.x -= 0.2;
		
		if (__num < 0)
		{
			__num = 0;
		}
		
		__score.text = "Score: " + __num;
		
		var key:Int = FlxG.keys.firstJustPressed();
		
		if (key == FlxKey.NONE)
		{
			return;
		}
		
		if (key == FlxKey.SPACE)
		{
			return;
		}
		
		if (key == FlxKey.F9)
		{
			return;
		}
		
		if (key == FlxKey.SHIFT)
		{
			return;
		}
		
		if (key == FlxKey.BACKSPACE)
		{
			__message.text = __message.text.substring(0, __message.text.length - 1);
			
			//FlxG.sound.play(AssetPaths.error__ogg);
			
			return;
		}
		
		if (key == FlxKey.ENTER)
		{
			var word:String = __message.text.toUpperCase();
			
			__message.text = "";
			
			if (__menu)
			{
				if (word == "RESET")
				{
					FlxG.resetState();
					
					return;
				}
				
				if (word == "START" && __group_hearts.members.length > 0)
				{
					__menu = false;	
					
					__logo.kill();
					
					setLevel();
					
					__sfx_ambient.stop();
					
					__sfx_music.play(true);
					
					return;
				}
				
				FlxG.sound.play(AssetPaths.error__ogg);
				
				return;
			}
			
			for (i in 0...__group_enemies.length) 
			{
				if (__group_enemies.members[i].message == word)
				{
					FlxG.sound.play(AssetPaths.missle_launch__ogg);
					
					add(new Missle(__group_enemies.members[i]));
					
					return;
				}
			}
			
			//__message.text = __message.text.substring(0, __message.text.length - 1);
			
			FlxG.sound.play(AssetPaths.error__ogg);
			
			__num -= 50;
		}
		else 
		{
			var letter:String = String.fromCharCode(key).toUpperCase();
			
			__message.text += letter;
		}
		
		
		
		//__emitter.start(true, 0.1, 2);
	}
	
	public var side:Bool = true;
	
	private function spawnEnemy(Timer:FlxTimer):Void
	{
		var positionX:Int = FlxG.random.int(0, 960); 
		
		if (side)
		{
			positionX += 960;
			
			side = false;
		}
		else 
		{
			side = true;
		}
		
		var word:String = __words[0];
		
		__words.splice(0, 1);
		
		var enemy:Enemy = new Enemy(positionX, -24, this, word);
		
		__group_enemies.add(enemy);
		
		add(enemy);
		
		if (__timer_enemySpawn.finished)
		{
			__timer_newWave.start(3, newWave);
		}
	}
	
	public function newWave(Timer:FlxTimer):Void
	{
		__level += 1;
		
		FlxG.sound.play(AssetPaths.wave__ogg, 0.8);
		
		setLevel();
	}
	
	public function emitSmoke(x:Float, y:Float):Void
	{
		__emitter.x = x - 39;
		__emitter.y = y;
		
		for (i in 0...20)
		{
			var particle:FlxParticle = new FlxParticle();
			
			particle.loadGraphic(AssetPaths.smoke__png, false);
			
			particle.exists = false;
			
			__emitter.add(particle);
		}
		
		__emitter.start(true, 0.1, 20);
	}
	
	public function setLevel():Void
	{
		switch (__level) 
		{
			case 1:
				
				__words = Global.level_1;
				
				FlxG.random.shuffle(__words);
				
				__goal = 20;
				
				__speed = 100;
				
				__timer_enemySpawn.start(1.0, spawnEnemy, __goal);
				
			case 2:
				
				__words = Global.level_2;
				
				FlxG.random.shuffle(__words);
				
				__goal = 20;
				
				__speed = 100;
				
				__timer_enemySpawn.start(1.0, spawnEnemy, __goal);
				
			case 3:
				
				__words = Global.level_3;
				
				FlxG.random.shuffle(__words);
				
				__goal = 20;
				
				__speed = 90;
				
				__timer_enemySpawn.start(2.0, spawnEnemy, __goal);
				
			default:
				
		}
	}
	
	public function reduce():Void
	{
		if (__group_hearts.members.length > 0)
		{
			__group_hearts.members[__group_hearts.members.length - 1].kill();
			
			__group_hearts.members.pop();
		}
		
		if (__group_hearts.members.length == 0)
		{
			//__group_hearts.members[__group_hearts.members.length - 1].kill();
			
			//__group_hearts.members.pop();
			
			__menu = true;
			
			add(__gameOver);
		}
	}
}
